SystemOrganization addCategory: #'Epic-Library'!

Object subclass: #EAuthor
	instanceVariableNames: 'firstName lastName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Epic-Library'!

!EAuthor methodsFor: 'accessing' stamp: 'RS 10/18/2010 16:37'!
firstName
	"Answer the value of firstName"

	^ firstName! !

!EAuthor methodsFor: 'accessing' stamp: 'RS 10/18/2010 16:37'!
firstName: anObject
	"Set the value of firstName"

	firstName := anObject! !

!EAuthor methodsFor: 'accessing' stamp: 'RS 10/18/2010 16:37'!
lastName
	"Answer the value of lastName"

	^ lastName! !

!EAuthor methodsFor: 'accessing' stamp: 'RS 10/18/2010 16:37'!
lastName: anObject
	"Set the value of lastName"

	lastName := anObject! !

Object subclass: #EBook
	instanceVariableNames: 'isbn title authors copies lendings'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Epic-Library'!

!EBook class methodsFor: 'as yet unclassified' stamp: 'sec 10/19/2010 17:24'!
descriptionCopies
	^ MANumberDescription new
		selectorAccessor: #copies;
		label: 'Number of copies';
		priority: 30;
		default: 1;
		beRequired;
		yourself! !

!EBook class methodsFor: 'as yet unclassified' stamp: 'sec 10/19/2010 17:19'!
descriptionISBN
	^ MAStringDescription new
		selectorAccessor: #isbn;
		label: 'ISBN';
		priority: 20;
		default: '';
		beRequired;
		yourself! !

!EBook class methodsFor: 'as yet unclassified' stamp: 'sec 10/19/2010 17:19'!
descriptionTitle
	^ MAStringDescription new
		selectorAccessor: #title;
		label: 'Title';
		priority: 10;
		default: '';
		beRequired;
		yourself! !

!EBook methodsFor: 'accessing' stamp: 'RS 10/20/2010 16:40'!
addLending: aLending
	self lendings add: aLending.! !

!EBook methodsFor: 'accessing' stamp: 'RS 10/18/2010 16:36'!
authors
	"Answer the value of authors"

	^ authors! !

!EBook methodsFor: 'accessing' stamp: 'RS 10/18/2010 16:36'!
authors: anObject
	"Set the value of authors"

	authors := anObject! !

!EBook methodsFor: 'accessing' stamp: 'RS 10/18/2010 20:39'!
copies
	"Answer the value of copies"

	^ copies! !

!EBook methodsFor: 'accessing' stamp: 'RS 10/18/2010 20:39'!
copies: anObject
	"Set the value of copies"

	copies := anObject! !

!EBook methodsFor: 'initialize-release' stamp: 'RS 10/20/2010 17:04'!
descriptionLentCopies
	^ MANumberDescription new
		selectorAccessor: #lentCopies;
		label: 'Number of lent copies';
		priority: 40;
		default: 0;
		beReadonly;
		beRequired;
		yourself! !

!EBook methodsFor: 'accessing' stamp: 'RS 10/20/2010 17:03'!
descriptionReport
	^ (self description 
		select: [:each | #(title isbn copies lentCopies) includes: each accessor selector ])
		add: self descriptionLentCopies;
		yourself.! !

!EBook methodsFor: 'initialize-release' stamp: 'RS 10/20/2010 16:19'!
initialize
	self 
		authors: OrderedCollection new;
		lendings: OrderedCollection new;
		copies: 1.
	! !

!EBook methodsFor: 'initialize-release' stamp: 'RS 10/20/2010 17:09'!
isAvailable
	^(self copies - self lentCopies) > 0! !

!EBook methodsFor: 'accessing' stamp: 'RS 10/18/2010 16:36'!
isbn
	"Answer the value of isbn"

	^ isbn! !

!EBook methodsFor: 'accessing' stamp: 'RS 10/18/2010 16:36'!
isbn: anObject
	"Set the value of isbn"

	isbn := anObject! !

!EBook methodsFor: 'accessing' stamp: 'RS 10/20/2010 16:17'!
lendings
	"Answer the value of lendings"

	^ lendings! !

!EBook methodsFor: 'accessing' stamp: 'RS 10/20/2010 16:17'!
lendings: anObject
	"Set the value of lendings"

	lendings := anObject! !

!EBook methodsFor: 'accessing' stamp: 'RS 10/20/2010 16:58'!
lentCopies
	^(self lendings select: [:each | each hasBeenReturned not ]) size.! !

!EBook methodsFor: 'accessing' stamp: 'RS 10/18/2010 16:36'!
title
	"Answer the value of title"

	^ title! !

!EBook methodsFor: 'accessing' stamp: 'RS 10/18/2010 16:36'!
title: anObject
	"Set the value of title"

	title := anObject! !

Object subclass: #EImageDatabase
	instanceVariableNames: ''
	classVariableNames: 'Books'
	poolDictionaries: ''
	category: 'Epic-Library'!

!EImageDatabase class methodsFor: 'as yet unclassified' stamp: 'RS 10/18/2010 20:20'!
books
	^ Books ifNil: [Books := OrderedCollection new]! !

Object subclass: #ELending
	instanceVariableNames: 'book startDate endDate person'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Epic-Library'!

!ELending class methodsFor: 'as yet unclassified' stamp: 'RS 10/20/2010 16:05'!
descriptionPerson
	^ MAStringDescription new
		selectorAccessor: #person;
		label: 'Person';
		priority: 10;
		default: '';
		beRequired;
		yourself! !

!ELending class methodsFor: 'as yet unclassified' stamp: 'RS 10/20/2010 16:14'!
descriptionStartDate
	^ MADescription new
		selectorAccessor: #startDate;
		label: 'Start date';
		priority: 30;
		default: Date today;
		beRequired;
		yourself! !

!ELending class methodsFor: 'as yet unclassified' stamp: 'RS 10/20/2010 17:08'!
newWithBook: aBook
	|anObject|
	anObject  := self new.
	anObject book: aBook.
	aBook addLending: anObject.
	^ anObject.! !

!ELending methodsFor: 'accessing' stamp: 'RS 10/20/2010 16:02'!
book
	"Answer the value of book"

	^ book! !

!ELending methodsFor: 'accessing' stamp: 'RS 10/20/2010 16:15'!
book: anObject
	"Set the value of book"

	book := anObject! !

!ELending methodsFor: 'accessing' stamp: 'RS 10/20/2010 16:02'!
endDate
	"Answer the value of endDate"

	^ endDate! !

!ELending methodsFor: 'accessing' stamp: 'RS 10/20/2010 16:02'!
endDate: anObject
	"Set the value of endDate"

	endDate := anObject! !

!ELending methodsFor: 'accessing' stamp: 'RS 10/20/2010 16:50'!
hasBeenReturned
	^self endDate notNil! !

!ELending methodsFor: 'accessing' stamp: 'RS 10/20/2010 16:02'!
person
	"Answer the value of person"

	^ person! !

!ELending methodsFor: 'accessing' stamp: 'RS 10/20/2010 16:02'!
person: anObject
	"Set the value of person"

	person := anObject! !

!ELending methodsFor: 'accessing' stamp: 'RS 10/20/2010 16:50'!
return
	self endDate: Date today.! !

!ELending methodsFor: 'accessing' stamp: 'RS 10/20/2010 16:02'!
startDate
	"Answer the value of startDate"

	^ startDate! !

!ELending methodsFor: 'accessing' stamp: 'RS 10/20/2010 16:02'!
startDate: anObject
	"Set the value of startDate"

	startDate := anObject! !

WAComponent subclass: #EBookComponent
	instanceVariableNames: 'books menuComponent listComponent report'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Epic-Library'!

!EBookComponent methodsFor: 'accessing' stamp: 'RS 10/18/2010 18:40'!
books
	"Answer the value of books"

	^ books! !

!EBookComponent methodsFor: 'accessing' stamp: 'RS 10/18/2010 18:40'!
books: anObject
	"Set the value of books"

	books := anObject! !

!EBookComponent methodsFor: 'rendering' stamp: 'sec 10/19/2010 15:03'!
children
	^Array with: self menuComponent with: self report.! !

!EBookComponent methodsFor: 'as yet unclassified' stamp: 'sec 10/19/2010 17:13'!
createBook
	|book|
	book := self call: EBook new asComponent addValidatedForm.
	book ifNotNil: [self books add: book. self refreshReport. ].! !

!EBookComponent methodsFor: 'as yet unclassified' stamp: 'sec 10/19/2010 17:13'!
deleteBook: aBook
	self books remove: aBook ifAbsent: [].
	self refreshReport.! !

!EBookComponent methodsFor: 'rendering' stamp: 'sec 10/19/2010 17:13'!
editBook: aBook
	self call: (aBook asComponent) addValidatedForm.
	self refreshReport.! !

!EBookComponent methodsFor: 'as yet unclassified' stamp: 'sec 10/19/2010 15:03'!
initialize
	super initialize.
	
	self books: EImageDatabase books.
	
	self initializeReport.
	self initializeMenuComponent.! !

!EBookComponent methodsFor: 'initialize-release' stamp: 'RS 10/18/2010 19:46'!
initializeMenuComponent
	self menuComponent: (EMenuComponent new
			addEntry: 'New book' withAction: [self createBook];
			addEntry: 'List books' withAction: [];
			 yourself)! !

!EBookComponent methodsFor: 'initialize-release' stamp: 'RS 10/20/2010 17:23'!
initializeReport
	self report: (MAReport
		rows: self books
		description: EBook new descriptionReport).
	self report
		addColumn: (MACommandColumn new
			addCommandOn: self selector: #editBook: text: 'edit';
			yourself);
		addColumn: (MACommandColumn new
			addCommandOn: self selector: #deleteBook: text: 'delete';
			yourself);
		addColumn: (MACommandColumn new
			filter: false; 
			propertyAt: #filterValue put: #isAvailable;
			addCommandOn: self selector: #lendBook: text: 'lend';
			yourself).! !

!EBookComponent methodsFor: 'rendering' stamp: 'RS 10/20/2010 17:08'!
lendBook: aBook
	aBook isAvailable ifTrue: [
		self call: (ELending newWithBook: aBook) asComponent addValidatedForm.
		self refreshReport.
		].! !

!EBookComponent methodsFor: 'accessing' stamp: 'RS 10/18/2010 19:43'!
menuComponent
	"Answer the value of menuComponent"

	^ menuComponent! !

!EBookComponent methodsFor: 'accessing' stamp: 'RS 10/18/2010 19:43'!
menuComponent: anObject
	"Set the value of menuComponent"

	menuComponent := anObject! !

!EBookComponent methodsFor: 'as yet unclassified' stamp: 'sec 10/19/2010 17:14'!
refreshReport
	self report rows: self books.! !

!EBookComponent methodsFor: 'rendering' stamp: 'sec 10/19/2010 15:02'!
renderContentOn: html 
	html heading: 'Books'.
	html div with: self menuComponent.
	html div with: self report.! !

!EBookComponent methodsFor: 'accessing' stamp: 'sec 10/19/2010 14:46'!
report
	"Answer the value of report"

	^ report! !

!EBookComponent methodsFor: 'accessing' stamp: 'sec 10/19/2010 14:46'!
report: anObject
	"Set the value of report"

	report := anObject! !

!EBookComponent methodsFor: 'as yet unclassified' stamp: 'RS 10/18/2010 18:55'!
testBooks
	^ OrderedCollection 
		with: (EBook new 
			isbn: '3551551677';
			title: 'Harry Potter und der Stein der Weisen')
		with: (EBook new 
			isbn: '3551551685';
			title: 'Harry Potter und die Kammer des Schreckens')! !

WAComponent subclass: #ELibrary
	instanceVariableNames: 'bookComponent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Epic-Library'!

!ELibrary class methodsFor: 'as yet unclassified' stamp: 'RS 10/18/2010 21:21'!
canBeRoot
	^ true! !

!ELibrary methodsFor: 'accessing' stamp: 'sec 10/18/2010 22:32'!
bookComponent
	"Answer the value of bookComponent"

	^ bookComponent! !

!ELibrary methodsFor: 'accessing' stamp: 'sec 10/18/2010 22:32'!
bookComponent: anObject
	"Set the value of bookComponent"

	bookComponent := anObject! !

!ELibrary methodsFor: 'accessing' stamp: 'sec 10/18/2010 22:41'!
children
	^Array with: self bookComponent.! !

!ELibrary methodsFor: 'initialize-release' stamp: 'sec 10/18/2010 22:40'!
initialize
	super initialize.
	self bookComponent: EBookComponent new.! !

!ELibrary methodsFor: 'initialize-release' stamp: 'sec 10/18/2010 22:41'!
renderContentOn: html
	html render: self bookComponent.! !

WAComponent subclass: #EMenuComponent
	instanceVariableNames: 'entries'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Epic-Library'!

!EMenuComponent methodsFor: 'as yet unclassified' stamp: 'RS 10/18/2010 19:38'!
addEntry: aString withAction: aBlock
	^ self entries add: aString -> aBlock! !

!EMenuComponent methodsFor: 'accessing' stamp: 'RS 10/18/2010 19:38'!
entries
	"Answer the value of entries"

	^ entries! !

!EMenuComponent methodsFor: 'accessing' stamp: 'RS 10/18/2010 19:38'!
entries: anObject
	"Set the value of entries"

	entries := anObject! !

!EMenuComponent methodsFor: 'as yet unclassified' stamp: 'RS 10/18/2010 19:39'!
initialize
	super initialize.	
	self entries: OrderedCollection new! !

!EMenuComponent methodsFor: 'as yet unclassified' stamp: 'RS 10/18/2010 19:37'!
renderContentOn: html 
	self entries
		do: [:entry | html anchor callback: entry value;
				 with: entry key]
		separatedBy: [html space]! !
